/*
 * Խػ! - ΥեGladeˤäƤޤ.
 */

#ifdef HAVE_CONFIG_H
#  include <config.h>
#endif

#include <sys/types.h>
#include <sys/stat.h>
#include <unistd.h>
#include <string.h>

#include <gdk/gdkkeysyms.h>
#include <gtk/gtk.h>

#include "callbacks.h"
#include "interface.h"
#include "support.h"

GtkWidget*
create_mainwin (void)
{
  GtkWidget *mainwin;
  GtkWidget *screen;

  mainwin = gtk_window_new (GTK_WINDOW_TOPLEVEL);
  gtk_widget_set_name (mainwin, "mainwin");
  gtk_object_set_data (GTK_OBJECT (mainwin), "mainwin", mainwin);
  gtk_widget_set_events (mainwin, GDK_EXPOSURE_MASK | GDK_BUTTON1_MOTION_MASK | GDK_BUTTON_PRESS_MASK | GDK_BUTTON_RELEASE_MASK);
  gtk_window_set_title (GTK_WINDOW (mainwin), _("Limo Theme Clock"));
  gtk_window_set_policy (GTK_WINDOW (mainwin), TRUE, TRUE, FALSE);

  screen = gtk_drawing_area_new ();
  gtk_widget_set_name (screen, "screen");
  gtk_widget_ref (screen);
  gtk_object_set_data_full (GTK_OBJECT (mainwin), "screen", screen,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (screen);
  gtk_container_add (GTK_CONTAINER (mainwin), screen);
  gtk_widget_set_events (screen, GDK_EXPOSURE_MASK);

  gtk_signal_connect (GTK_OBJECT (mainwin), "destroy",
                      GTK_SIGNAL_FUNC (on_mainwin_destroy),
                      NULL);
  gtk_signal_connect (GTK_OBJECT (mainwin), "button_press_event",
                      GTK_SIGNAL_FUNC (on_mainwin_button_press),
                      NULL);
  gtk_signal_connect (GTK_OBJECT (mainwin), "button_release_event",
                      GTK_SIGNAL_FUNC (on_mainwin_button_release),
                      NULL);
  gtk_signal_connect (GTK_OBJECT (mainwin), "motion_notify_event",
                      GTK_SIGNAL_FUNC (on_mainwin_motion_notify_event),
                      NULL);
  gtk_signal_connect (GTK_OBJECT (screen), "expose_event",
                      GTK_SIGNAL_FUNC (on_screen_expose_event),
                      NULL);

  return mainwin;
}

GtkWidget*
create_fileload (void)
{
  GtkWidget *fileload;
  GtkWidget *load_ok;
  GtkWidget *load_cancel;

  fileload = gtk_file_selection_new (_("Theme Select"));
  gtk_widget_set_name (fileload, "fileload");
  gtk_object_set_data (GTK_OBJECT (fileload), "fileload", fileload);
  gtk_container_set_border_width (GTK_CONTAINER (fileload), 10);
  GTK_WINDOW (fileload)->type = GTK_WINDOW_DIALOG;
  gtk_window_set_position (GTK_WINDOW (fileload), GTK_WIN_POS_MOUSE);

  load_ok = GTK_FILE_SELECTION (fileload)->ok_button;
  gtk_widget_set_name (load_ok, "load_ok");
  gtk_object_set_data (GTK_OBJECT (fileload), "load_ok", load_ok);
  gtk_widget_show (load_ok);
  GTK_WIDGET_SET_FLAGS (load_ok, GTK_CAN_DEFAULT);

  load_cancel = GTK_FILE_SELECTION (fileload)->cancel_button;
  gtk_widget_set_name (load_cancel, "load_cancel");
  gtk_object_set_data (GTK_OBJECT (fileload), "load_cancel", load_cancel);
  gtk_widget_show (load_cancel);
  GTK_WIDGET_SET_FLAGS (load_cancel, GTK_CAN_DEFAULT);

  gtk_signal_connect (GTK_OBJECT (load_ok), "clicked",
                      GTK_SIGNAL_FUNC (on_load_ok_clicked),
                      NULL);
  gtk_signal_connect (GTK_OBJECT (load_cancel), "clicked",
                      GTK_SIGNAL_FUNC (on_load_cancel_clicked),
                      NULL);

  return fileload;
}

GtkWidget*
create_menu1 (void)
{
  GtkWidget *menu1;
  GtkAccelGroup *menu1_accels;
  GtkWidget *loadrequest;
  GtkWidget *secondrequest;
  GtkWidget *__________1;
  GtkWidget *exit1;
  GtkAccelGroup *accel_group;

  accel_group = gtk_accel_group_new ();

  menu1 = gtk_menu_new ();
  gtk_widget_set_name (menu1, "menu1");
  gtk_object_set_data (GTK_OBJECT (menu1), "menu1", menu1);
  menu1_accels = gtk_menu_ensure_uline_accel_group (GTK_MENU (menu1));

  loadrequest = gtk_menu_item_new_with_label (_("Theme Load"));
  gtk_widget_set_name (loadrequest, "loadrequest");
  gtk_widget_ref (loadrequest);
  gtk_object_set_data_full (GTK_OBJECT (menu1), "loadrequest", loadrequest,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (loadrequest);
  gtk_container_add (GTK_CONTAINER (menu1), loadrequest);

  secondrequest = gtk_check_menu_item_new_with_label (_("Second-hand"));
  gtk_widget_set_name (secondrequest, "secondrequest");
  gtk_widget_ref (secondrequest);
  gtk_object_set_data_full (GTK_OBJECT (menu1), "secondrequest", secondrequest,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (secondrequest);
  gtk_container_add (GTK_CONTAINER (menu1), secondrequest);

  __________1 = gtk_menu_item_new ();
  gtk_widget_set_name (__________1, "__________1");
  gtk_widget_ref (__________1);
  gtk_object_set_data_full (GTK_OBJECT (menu1), "__________1", __________1,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (__________1);
  gtk_container_add (GTK_CONTAINER (menu1), __________1);
  gtk_widget_set_sensitive (__________1, FALSE);

  exit1 = gtk_menu_item_new_with_label (_("Exit"));
  gtk_widget_set_name (exit1, "exit1");
  gtk_widget_ref (exit1);
  gtk_object_set_data_full (GTK_OBJECT (menu1), "exit1", exit1,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (exit1);
  gtk_container_add (GTK_CONTAINER (menu1), exit1);
  gtk_widget_add_accelerator (exit1, "activate", accel_group,
                              GDK_Q, GDK_CONTROL_MASK,
                              GTK_ACCEL_VISIBLE);

  gtk_signal_connect (GTK_OBJECT (loadrequest), "activate",
                      GTK_SIGNAL_FUNC (on_loadrequest_activate),
                      NULL);
  gtk_signal_connect (GTK_OBJECT (secondrequest), "activate",
                      GTK_SIGNAL_FUNC (on_secondequest_activate),
                      NULL);
  gtk_signal_connect (GTK_OBJECT (exit1), "activate",
                      GTK_SIGNAL_FUNC (on_exit1_activate),
                      NULL);

  gtk_menu_set_accel_group (GTK_MENU (menu1), accel_group);

  return menu1;
}

GtkWidget*
create_error1 (void)
{
  GtkWidget *error1;
  GtkWidget *dialog_vbox2;
  GtkWidget *errorname;
  GtkWidget *dialog_action_area2;
  GtkWidget *button1;

  error1 = gtk_dialog_new ();
  gtk_widget_set_name (error1, "error1");
  gtk_object_set_data (GTK_OBJECT (error1), "error1", error1);
  gtk_window_set_title (GTK_WINDOW (error1), _("LiMo seal Error"));
  GTK_WINDOW (error1)->type = GTK_WINDOW_DIALOG;
  gtk_window_set_position (GTK_WINDOW (error1), GTK_WIN_POS_MOUSE);
  gtk_window_set_modal (GTK_WINDOW (error1), TRUE);
  gtk_window_set_policy (GTK_WINDOW (error1), TRUE, TRUE, FALSE);

  dialog_vbox2 = GTK_DIALOG (error1)->vbox;
  gtk_widget_set_name (dialog_vbox2, "dialog_vbox2");
  gtk_object_set_data (GTK_OBJECT (error1), "dialog_vbox2", dialog_vbox2);
  gtk_widget_show (dialog_vbox2);

  errorname = gtk_label_new (_("Theme Error."));
  gtk_widget_set_name (errorname, "errorname");
  gtk_widget_ref (errorname);
  gtk_object_set_data_full (GTK_OBJECT (error1), "errorname", errorname,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (errorname);
  gtk_box_pack_start (GTK_BOX (dialog_vbox2), errorname, FALSE, FALSE, 0);
  gtk_misc_set_alignment (GTK_MISC (errorname), 0.5, 1);
  gtk_misc_set_padding (GTK_MISC (errorname), 26, 14);

  dialog_action_area2 = GTK_DIALOG (error1)->action_area;
  gtk_widget_set_name (dialog_action_area2, "dialog_action_area2");
  gtk_object_set_data (GTK_OBJECT (error1), "dialog_action_area2", dialog_action_area2);
  gtk_widget_show (dialog_action_area2);
  gtk_container_set_border_width (GTK_CONTAINER (dialog_action_area2), 10);

  button1 = gtk_button_new_with_label (_("OK"));
  gtk_widget_set_name (button1, "button1");
  gtk_widget_ref (button1);
  gtk_object_set_data_full (GTK_OBJECT (error1), "button1", button1,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (button1);
  gtk_box_pack_start (GTK_BOX (dialog_action_area2), button1, FALSE, FALSE, 0);
  gtk_widget_set_usize (button1, 64, -2);

  gtk_signal_connect (GTK_OBJECT (button1), "clicked",
                      GTK_SIGNAL_FUNC (on_error1_ok),
                      NULL);

  return error1;
}

