/* =====================================================================

   LiMo - Liblary
      Rero2's Resistrict Data Archive System.
                   - 쥸դǡ֥ƥ

                                  Programed by Rero2 (K.Kunikane)

====================================================================== */

/* -------------------------------------------------------------
 --- History

  Feb.22.2000  ߷ס

-------------------------------------------------------------- */

/* -------------------------------------------------------------
 --- Preface

  lm_rrda_open        -- ֥եΥץ
  lm_rrda_close       -- ֥եΥ
  lm_rrda_check_open  -- ե뤬ץ󤵤Ƥ뤫

  lm_rrda_check_key   -- ꤵƤ뤫

  lm_rrda_check_data  -- ǡ¸ߤƤ뤫
  lm_rrda_data_size   -- ǡΥ֤
  lm_rrda_load_data   -- ǡɤ߹


-------------------------------------------------------------- */

/* -------------------------------------------------------------
 --- Include
-------------------------------------------------------------- */

#ifdef HAVE_CONFIG_H
#  include <config.h>
#endif

#include  <stdio.h>
#include  <stdlib.h>
#include  <string.h>
#include  <zlib.h>
#include  "lm_rrda.h"

/* --- ɸ२顼Ϥ뤫ɤ */
#define VERBOSE

/* --- νϥñ */
#define ZLIB_BUFSIZE  4096

/* --- 1եΥ() */
#define Z_OUTMAX 1024*1024*5

/* --- gzip إå flag byte */
#define ASCII_FLAG   0x01
#define HEAD_CRC     0x02
#define EXTRA_FIELD  0x04
#define ORIG_NAME    0x08
#define COMMENT      0x10
#define RESERVED     0xe0

/* -------------------------------------------------------------
 --- Ƽ
-------------------------------------------------------------- */


/* -------------------------------------------------------------
 --- Structure
-------------------------------------------------------------- */

typedef struct _rrda_file RRDAFile;
struct _rrda_file
{
  unsigned long  top;
  unsigned long  size;
  int            resist_flag;
};


/* -------------------------------------------------------------
 --- ؿ
-------------------------------------------------------------- */

/* --- ե椫ǥ쥯ȥǡФ */
void get_dir(void);

/* --- gz ǡΥإååȥå */
unsigned char *gz_header_check(unsigned char*, long);

/* ---  gz ǡषݥ󥿤֤ */
unsigned char *gunzip_data(unsigned char*, long, long*);

/* --- 夫ԤФʤ᤿ݥ󥿤֤ */
unsigned char *mem_gets(unsigned char*, int, unsigned char*);

/* --- եǥ쥯ȥ꤫õ */
void file_search(unsigned char*, RRDAFile*);

/* --- եɤ */
unsigned char *get_file(unsigned char*, long*);


/* -------------------------------------------------------------
 --- ѿ
-------------------------------------------------------------- */

/* --- ֥ե̾ */
static unsigned char *RRDAFilename;

/* ---  */
static unsigned char RRDAKey[4];

/* --- ɤɤΥե饰 */
static int RRDAKeyFlag = FALSE;

/* --- Directory ǡ */
static unsigned char *RRDADir_f = NULL;
static unsigned char *RRDADir_r = NULL;

/* -----------------------------------------------------------------------
 --- ץ
------------------------------------------------------------------------ */

/* -------------------------------------------------------------
  lm_rrda_open        -- ֥եΥץ

   filename - ֥եΥե̾
   key      - ʸΥȥ
   return : TRUE=ץλ, FALSE=ץԲ
-------------------------------------------------------------- */
int  lm_rrda_open(char *filename, char *key)
{
  int  i, f, l;

  /* --- ǡĤäƤȰΤǶ */
  lm_rrda_close();

  /* --- 顼 */
  if (filename == NULL) return(FALSE);

  /* --- Υԡ */
  f = 1;
  /* - ͤʤȤǧ */
  if (key != NULL) {
    for(i=0; i<4; i++) {
      if (key[i] == 0) {
	f = 0;
	break;
      }
    }
    if (key[4] != 0) {
      f = 0;
    }
    if (f == 0) {
      return(FALSE);
    }
    for(i=0; i<4; i++) {
      RRDAKey[i] = key[i];
    }
  }

  /* --- ե͡Υԡ */
  l = (int)strlen(filename);
  RRDAFilename = (char *)malloc((size_t)l + 1);
  if (RRDAFilename == NULL) return(FALSE);
  strcpy(RRDAFilename, filename);

  /* --- Directory ǡμ */
  get_dir();

  return(TRUE);
}


/* -------------------------------------------------------------
  lm_rrda_close       -- ֥եΥ

   return : void 
-------------------------------------------------------------- */
void  lm_rrda_close(void)
{
  /* --- Υꥢ */
  RRDAKey[0] = RRDAKey[1] = RRDAKey[2] = RRDAKey[3] = 0;
  RRDAKeyFlag = FALSE;

  /* --- ݻե̾γ */
  if (RRDAFilename != NULL) {
    free(RRDAFilename);
    RRDAFilename = NULL;
  }

  /* --- DIRǡγ */
  if (RRDADir_f != NULL) {
    free(RRDADir_f);
    RRDADir_f = NULL;
  }
  if (RRDADir_r != NULL) {
    free(RRDADir_r);
    RRDADir_r = NULL;
  }
}


/* -------------------------------------------------------------
  lm_rrda_check_open  -- ե뤬ץ󤵤Ƥ뤫

   return : 
-------------------------------------------------------------- */
int  lm_rrda_check_open(void)
{
  if ((RRDAFilename == NULL) || (RRDADir_f == NULL)) {
    return(FALSE);
  }
  return(TRUE);
}


/* -------------------------------------------------------------
  lm_rrda_check_key   -- ꤵƤ뤫

   return : 
-------------------------------------------------------------- */
int  lm_rrda_check_key(void)
{
  return(RRDAKeyFlag);
}


/* -------------------------------------------------------------
  lm_rrda_check_data  -- ǡ¸ߤƤ뤫

   return : 
-------------------------------------------------------------- */
int  lm_rrda_check_data(char *dataname)
{
  RRDAFile file;

  file_search(dataname, &file);
  if ((file.top == 0) || (file.size == 0)) {
    return(FALSE);
  }
  return(TRUE);
}


/* -------------------------------------------------------------
  lm_rrda_data_size   -- ǡΥ֤

   return : 
-------------------------------------------------------------- */
unsigned long  lm_rrda_data_size(char *dataname)
{
  unsigned char *t;
  long  s;

  t = get_file(dataname, &s);
  if (t == NULL) {
    s = 0;
  }
  else {
    free(t);
  }
  
  return(s);
}


/* -------------------------------------------------------------
  lm_rrda_load_data   -- ǡɤ߹

   return : 
-------------------------------------------------------------- */
void  *lm_rrda_load_data(char *dataname)
{
  return(get_file(dataname, NULL));
}



/* -----------------------------------------------------------------------
 --- ؿ
------------------------------------------------------------------------ */

/* -------------------------------------------------------------
  mem_gets      -- 夫ԤФʤ᤿ݥ󥿤֤
-------------------------------------------------------------- */
unsigned char *mem_gets(unsigned char *out, int max, unsigned char *in)
{
  int  i;

  for(i=0; i<max; i++) {
    if (*in == '\n') {
      out[i] = 0;
      in++;
      break;
    }
    else {
      out[i] = *in;
      in++;
    }
  }
  return(in);
}


/* -------------------------------------------------------------
  get_dir   -- ե椫ǥ쥯ȥǡФ
-------------------------------------------------------------- */
void get_dir(void)
{
  FILE  *fp;
  unsigned char line[256];
  unsigned char *zipdata, *work, *r_dir;
  unsigned char *start2, *end2;
  unsigned int  start, end, size, r_start, r_size, zbody_size;
  long  key_ptr, i;

  /* --- ե̤̾ꥨ顼 */
  if (RRDAFilename == NULL) {
#ifdef VERBOSE
      fprintf(stderr, "lm_rrda : filename missing.\n");
#endif
      return;
    }

  /* --- ե륪ץ */
  fp = fopen(RRDAFilename, "r");
  if (fp == NULL) {
#ifdef VERBOSE
    fprintf(stderr, "lm_rrda : file not open.(%s)\n", RRDAFilename);
#endif
    return;
  }

  /* --- ȾΥȥإåĴ٤ */
  fgets(line, 256, fp);
  if (line == NULL) {
#ifdef VERBOSE
    fprintf(stderr, "lm_rrda : dir_f header wrong(%s)\n", RRDAFilename);
#endif
    fclose(fp);
    return;
  }
  if ((line[0] == 'R') && (line[1] == 'R') &&
      (line[2] == 'D') && (line[3] == 'A')) {
    fgets(line, 256, fp);
    sscanf(line, "%08x\n", &size);
    fgets(line, 256, fp);
    sscanf(line, "%08x,%08x\n", &r_start, &r_size);
    /* -- ǡʬθ */
    start = ftell(fp);
    while(1) {
      fgets(line, 256, fp);
      end = ftell(fp);
      if (strncmp(line, "END", 3) == 0) break;
      /* -  */
      if (ftell(fp) >= size) break;
    }
    /* -- ǥ쥯ȥǡɤ߹ */
    RRDADir_f = (char *)malloc(end-start);
    if (RRDADir_f == NULL) {
#ifdef VERBOSE
      fprintf(stderr, "lm_rrda : dir_f cannot memory allocate.\n");
#endif
      fclose(fp);
      return;
    }
    fseek(fp, start, SEEK_SET);
    if (fread(RRDADir_f, sizeof(char), (end-start), fp) == 0) {
#ifdef VERBOSE
      fprintf(stderr, "lm_rrda : dir_f read error.(%s)\n", RRDAFilename);
#endif
      fclose(fp);
      free(RRDADir_f);
      RRDADir_f = NULL;
      return;
    }
  }
  else {
#ifdef VERBOSE
    fprintf(stderr, "lm_rrda : dir_f header wrong(%s)\n", RRDAFilename);
#endif
    fclose(fp);
    return;
  }

  /* --- Ⱦɤ߹ߤȸ */
  zipdata = (char*)malloc(r_size);
  if (zipdata == NULL) {
#ifdef VERBOSE
    fprintf(stderr, "lm_rrda : dir_r cannot memory allocate.\n");
#endif
    fclose(fp);
    return;
  }
  fseek(fp, r_start, SEEK_SET);
  if (fread(zipdata, sizeof(char), r_size, fp) == 0) {
#ifdef VERBOSE
    fprintf(stderr, "lm_rrda : dir_r read error.(%s)\n", RRDAFilename);
#endif
    fclose(fp);
    free(zipdata);
    return;
  }
  /* -- ʾǥǥ쥯ȥǡɤ߽ */
  fclose(fp);
  /* -- Υåȳ */
  RRDAKeyFlag = FALSE;
  if (RRDAKey[0] == 0) {
    free(zipdata);
    return;
  }
  key_ptr = r_start;
  work = zipdata;
  for(i=0; i<r_size; i++) {
    *work = (*work ^ 0xaa) ^ RRDAKey[key_ptr % 4];
    work++;
    key_ptr++;
  }
  /* -- Ⱦǥ쥯ȥϰ̤ƤΤǲ */
  work = gz_header_check((unsigned char *)zipdata, r_size);
  if (work == NULL) {
    /* -- 㤦ǡƤ뤫 */
    free(zipdata);
    return;
  }
  zbody_size = r_size - (long)(work - zipdata);
  r_dir = gunzip_data(work, zbody_size, NULL);
  free(zipdata);
  if (r_dir == NULL) {
    /* -- ǤޤǤ */
    return;
  }
  /* -- Ⱦإåθ */
  if ((r_dir[0] == 'R') && (r_dir[1] == 'R') &&
      (r_dir[2] == 'D') && (r_dir[3] == 'A')) {
    /* - äͤǤ */
    RRDAKeyFlag = TRUE;
    work = mem_gets(line, 256, r_dir);
    work = mem_gets(line, 256, work);
    work = mem_gets(line, 256, work);
    /* -- ǡʬθ */
    start2 = work;
    while(1) {
      work = mem_gets(line, 256, work);
      end2 = work;
      if (strncmp(line, "END", 3) == 0) break;
      /* -  */
      if (work >= (r_dir + r_size)) break;
    }
    /* -- ǥ쥯ȥǡɤ߹ */
    RRDADir_r = (char *)malloc(end2-start2);
    if (RRDADir_r == NULL) {
#ifdef VERBOSE
      fprintf(stderr, "lm_rrda : dir_r cannot memory allocate.\n");
#endif
      free(r_dir);
      return;
    }
    memcpy(RRDADir_r, start2, (end2-start2));
    free(r_dir);
  }
  else {
    /* -- 㤦ǡƤ뤫 */
    free(r_dir);
    return;
  }
}


/* -------------------------------------------------------------
  gz_header_check  -- gz ǡΥإååȥå

    zlib  gzio.c ؿ check_header() 򻲹ͤ
    ɬפȤǥ饤ȤΡ
-------------------------------------------------------------- */
unsigned char *gz_header_check(unsigned char *data, long size)
{
  unsigned char   *limit, flags;
  unsigned long  l;

  limit = data + size;

  /* --- ޥåʥСΥå */
  if ((data[0] != 0x1f) || (data[1] != 0x8b)) {
    /* -- Error 㤦ǡƤ뤫 */
    return(NULL);
  }
  data += 2;
  /* --- ե᥽åɤΥå */
  /* Z_DEFLATED  zlib.h 򻲾 */
  flags = data[1];
  if ((data[0] != Z_DEFLATED) || ((flags & RESERVED) != 0)) {
    /* -- Error 㤦ǡƤ뤫 */
    return(NULL);
  }
  /* time ξޤȤƥå */
  data += 8;
  /* --- extra եɤΥå */
  if ((flags & EXTRA_FIELD) != 0) {
    l = (unsigned long)data[0] + (((unsigned long)data[1]) << 8);
    data += (l + 2);
  }
  /* --- ꥸʥե͡Υå */
  if ((flags & ORIG_NAME) != 0) {
    while(*data != 0) {
      data++;
      if (data > limit) return(NULL);
    }
    data++;
  }
  /* --- ե륳ȤΥå */
  if ((flags & COMMENT) != 0) {
    while(*data != 0) {
      data++;
      if (data > limit) return(NULL);
    }
    data++;
  }
  /* --- إåCRC */
  if ((flags & HEAD_CRC) != 0) {
    data += 2;
  }
  /* --- ݥ󥿰å */
  if (data > limit) return(NULL);
  /* --- إåå׽λ */

  return(data);
}


/* -------------------------------------------------------------
  gunzip_data   --  gz ǡषݥ󥿤֤

    إåϴ˥åפư̥ǡΤؤΥݥ󥿤
    ϤƤΤȤ롣
-------------------------------------------------------------- */
unsigned char *gunzip_data(unsigned char *data, long size, long *filesize)
{
  z_stream  z;
  unsigned char  *outtmp, *output;
  unsigned long  outptr;
  int  status;

  /* --- λ() */
  z.zalloc = Z_NULL;
  z.zfree  = Z_NULL;
  z.opaque = Z_NULL;

  /* --- Ÿ̥Хåե */
  output = NULL;
  outptr = 0;
  outtmp = (unsigned char *)malloc(ZLIB_BUFSIZE);
  if (outtmp == NULL) {
#ifdef VERBOSE
    fprintf(stderr, "lm_rrda : decompress malloc error.\n");
#endif
    return(NULL);
  }

  /* --- zlib  */
  z.next_in = Z_NULL;
  z.avail_in = 0;
  if (inflateInit2(&z, -MAX_WBITS) != Z_OK) {
#ifdef VERBOSE
    fprintf(stderr, "lm_rrda : zlib init error.\n");
#endif
    return(NULL);
  }

  /* --- ǡ */
  z.avail_in = size;
  z.next_in = data;
  z.avail_out = ZLIB_BUFSIZE;
  z.next_out = outtmp;
  status = Z_OK;

  /* ---  */
  while((status != Z_STREAM_END) && (outptr < Z_OUTMAX)) {
    /* -- zlib call */
    status = inflate(&z, Z_NO_FLUSH);
    /* -- inflate error */
    if ((status != Z_OK) && (status != Z_STREAM_END)) {
#ifdef VERBOSE
      fprintf(stderr, "lm_rrda : decompress error.\n");
#endif
      free(outtmp);
      if (output != NULL) free(output);
      return(NULL);
    }
    /* -- ǡɲݻ */
    if (output == NULL) {
      output = (unsigned char *)malloc(ZLIB_BUFSIZE);
      if (output == NULL) {
#ifdef VERBOSE
	fprintf(stderr, "lm_rrda : decompress output malloc error.\n");
#endif
	free(outtmp);
	return(NULL);
      }
      memcpy(output, outtmp, ZLIB_BUFSIZE);
      outptr = (ZLIB_BUFSIZE-z.avail_out);
      z.avail_out = ZLIB_BUFSIZE;
      z.next_out = outtmp;
    }
    else {
      output = (unsigned char *)realloc(output, outptr+(ZLIB_BUFSIZE-z.avail_out));
      memcpy(output+outptr, outtmp, (ZLIB_BUFSIZE-z.avail_out));
      outptr += (ZLIB_BUFSIZE-z.avail_out);
      z.avail_out = ZLIB_BUFSIZE;
      z.next_out = outtmp;
    }
  }

  /* --- zlib 夫Ť */
  if (inflateEnd(&z) != Z_OK) {
#ifdef VERBOSE
    fprintf(stderr, "lm_rrda : zlib end error.\n");
#endif
    return(NULL);
  }

  /* --- ̤֤ƽλ */
  if (filesize != NULL) {
    *filesize = outptr;
  }
  free(outtmp);
  return(output);
}


/* -------------------------------------------------------------
  file_search   -- եǥ쥯ȥ꤫õ
-------------------------------------------------------------- */
void file_search(unsigned char *name, RRDAFile *filedata)
{
  unsigned char *dir, line[256], dataname[256];
  unsigned int  start, size;
  int  stat;

  /* --- 顼Υǥե */
  filedata->top  = 0;
  filedata->size = 0;
  filedata->resist_flag = FALSE;

  /* --- ե꡼ꥢǡõ */
  if (RRDADir_f != NULL) {
    dir = RRDADir_f;
    stat = 1;
    while(stat == 1) {
      dir = mem_gets(line, 256, dir);
      if (strncmp(line, "END", 3) == 0) break;
      sscanf(line, "%08x,%08x,%s\n", &start, &size, dataname);
      if (strcmp(dataname, name) == 0) {
	filedata->top  = start;
	filedata->size = size;
	filedata->resist_flag = FALSE;
	stat = 0;
      }
    }
  }

  /* --- ¥ꥢǡõ */
  if (RRDADir_r != NULL) {
    dir = RRDADir_r;
    stat = 1;
    while(stat == 1) {
      dir = mem_gets(line, 256, dir);
      if (strncmp(line, "END", 3) == 0) break;
      sscanf(line, "%08x,%08x,%s\n", &start, &size, dataname);
      if (strcmp(dataname, name) == 0) {
	filedata->top  = start;
	filedata->size = size;
	filedata->resist_flag = TRUE;
	stat = 0;
      }
    }
  }
}


/* -------------------------------------------------------------
  get_file      -- եɤ
-------------------------------------------------------------- */
unsigned char *get_file(unsigned char *dataname, long *size)
{
  FILE  *fp;
  RRDAFile file;
  unsigned char *zipwork, *work, *dataptr;
  long  i, zbody_size, bodysize, key_ptr;

  /* --- ե̤̾ꥨ顼 */
  if (RRDAFilename == NULL) {
#ifdef VERBOSE
    fprintf(stderr, "lm_rrda : filename missing.\n");
#endif
    return(NULL);
  }
  /* --- ե륪ץ */
  fp = fopen(RRDAFilename, "r");
  if (fp == NULL) {
#ifdef VERBOSE
    fprintf(stderr, "lm_rrda : file not open.(%s)\n", RRDAFilename);
#endif
    return(NULL);
  }
  /* --- Ūե */
  file_search(dataname, &file);
  if ((file.top == 0) || (file.size == 0)) {
    fclose(fp);
    return(NULL);
  }
  /* --- ̥ǡɤ߹ߥ */
  zipwork = (unsigned char *)malloc(file.size);
  if (zipwork == NULL) {
#ifdef VERBOSE
    fprintf(stderr, "lm_rrda : fileload cannot memory allocate.\n");
#endif
    fclose(fp);
    return(NULL);
  }
  /* --- ǡɤ߹(̤) */
  fseek(fp, file.top, SEEK_SET);
  if (fread(zipwork, sizeof(char), file.size, fp) != file.size) {
#ifdef VERBOSE
    fprintf(stderr, "lm_rrda : file read error.(%s - %s)\n",
	    RRDAFilename, dataname);
#endif
    fclose(fp);
    free(zipwork);
    return(NULL);
  }
  /* -- ʾǥǥ쥯ȥǡɤ߽ */
  fclose(fp);
  /* -- γ */
  if (file.resist_flag == TRUE) {
    key_ptr = file.top;
    work = zipwork;
    for(i=0; i<file.size; i++) {
      *work = (*work ^ 0xaa) ^ RRDAKey[key_ptr % 4];
      work++;
      key_ptr++;
    }
  }
  /* -- ̲ */
  work = gz_header_check((unsigned char *)zipwork, file.size);
  if (work == NULL) {
    /* -- 㤦ǡƤ뤫 */
    free(zipwork);
    return(NULL);
  }
  zbody_size = file.size - (long)(work - zipwork);
  dataptr = gunzip_data(work, zbody_size, &bodysize);
  free(zipwork);
  if (dataptr == NULL) {
    /* -- ǤޤǤ */
    return(NULL);
  }

  if (size != NULL) {
    *size = bodysize;
  }
  return(dataptr);
}

