/* =====================================================================

   LiMo - Theme clock
      Clock Theme Main.  - ơ޺ؤǽ

                                  Programed by Rero2 (K.Kunikane)

====================================================================== */

/* -------------------------------------------------------------
 --- History

  Mar.26.2000  

-------------------------------------------------------------- */

/* -------------------------------------------------------------
 --- Preface

  RRMainInit          -- ʤ
  RRMain              -- ׻,
  RRMainFree          -- ᥤץཪλ()
  RRMainSetTheme      -- ơޥեλ

  RRMainDragStart     -- ɥĤޤ줿
  RRMainDragEnd       -- ɥΥ줿
  RRMainDragMove      -- ɥư

-------------------------------------------------------------- */

/* -------------------------------------------------------------
 --- Include
-------------------------------------------------------------- */

#include <math.h>
#include <time.h>
#include <gdk/gdk.h>
#include <gtk/gtk.h>
#include <gdk-pixbuf/gdk-pixbuf.h>
#include  "rr_main.h"
#include  "rr_screen.h"
#include  "lm_pix_rot.h"
#include  "tm_config.h"
#include  "tm_display.h"


/* -------------------------------------------------------------
 --- Ƽ
-------------------------------------------------------------- */


/* -------------------------------------------------------------
 --- Structure
-------------------------------------------------------------- */


/* -------------------------------------------------------------
 --- ؿ
-------------------------------------------------------------- */


/* -------------------------------------------------------------
 --- ѿ
-------------------------------------------------------------- */

/* --- ߤγ */
static gint  interval;
static gint  int_handle;

/* --- ɥɥåࡼִϢ */
static gboolean  win_move;
static gint cur_x, cur_y;
static gint owx, owy;


/* -----------------------------------------------------------------------
 --- ץ
------------------------------------------------------------------------ */

/* -------------------------------------------------------------
  RRMainInit       -- ᥤץʤ

   return : void
   void

-------------------------------------------------------------- */
void RRMainInit(void)
{
  win_move = FALSE;

  /* -- GdkRGB ν */
  gdk_rgb_init();

  /* -- ץ饤ȴν */
  RRSpritemanInit();

  /* -- ߳ */
  RRMainInterval(1000/5);
}


/* -------------------------------------------------------------
  RRMainFree       -- ᥤץཪλ

   return : void
   void

-------------------------------------------------------------- */
void RRMainFree(void)
{
  if (int_handle != 0) gtk_timeout_remove(int_handle);
  /* --- ߤΥơޤ */
  TMConfigFree(TMConfigGet());
  /* -- ץ饤ȴβ */
  RRSpritemanFree();
}


/* -------------------------------------------------------------
  RRMainInterval   -- ߻֤

   return : void
   gint n(n sec)
-------------------------------------------------------------- */
void RRMainInterval(gint n)
{
  if (int_handle != 0) gtk_timeout_remove(int_handle);
  int_handle = gtk_timeout_add(1000/n, (GtkFunction)RRMain, NULL);
  /* --- ͤݻ */
  interval = n;
}


/* -------------------------------------------------------------
  RRMainIntervalTime  -- ߻֤ɤߤ

   return : n (1/n sec)
   void
-------------------------------------------------------------- */
gint RRMainIntervalTime(void)
{
  return(interval);
}


/* -------------------------------------------------------------
  RRMainIntervalStop  -- 

   return : void
   void
-------------------------------------------------------------- */
void  RRMainIntervalStop(void)
{
  if (int_handle != 0) {
    gtk_timeout_remove(int_handle);
    int_handle = 0;
  }
}


/* -------------------------------------------------------------
  RRMainSetTheme      -- ơޥեλ

   return : ɤ߹ߤݤ
   gchar *filename = ɤ߹ߤե̾
-------------------------------------------------------------- */
gboolean      RRMainSetTheme(gchar *filename)
{
  LMTC *theme, *oldtheme;
  gboolean  result;
  time_t  now_time;

  result = FALSE;

  /* --- ơޥǡɤ߹ */ 
  theme = TMConfigRead(filename);
  if (theme != NULL) {
    /* -- ɤ߹,ɽ */
    result = TRUE;
    /* - ɽ */
    now_time = time(NULL);
    TMDispInit(theme, now_time);
    /* - Υơޤ˴ */
    oldtheme = TMConfigSet(theme);
    if (oldtheme != NULL) TMConfigFree(oldtheme);
  }
  else {
    /* -- ɤ߹߼ */
    result = FALSE;
  }

  /* - ޤ */
  return(result);
}



/* -------------------------------------------------------------
  RRMain     -- Ū

   return : void
    void
-------------------------------------------------------------- */
gint  RRMain(void)
{
  LMTC *theme;
  time_t  now_time;

  /* --- ɽ */
  now_time = time(NULL);
  theme = TMConfigGet();
  TMDispSet(theme, now_time);

  /* --- ץ饤ȥޥ͡ */
  RRSpritemanAutoUpdate(0);

  /* --- Graphic Buffer Υå */
  RRScreenSwitch();

  return 1;
}


/* -------------------------------------------------------------
  RRMainDragStart     -- ɥĤޤ줿

   return : void
   void
-------------------------------------------------------------- */
void  RRMainDragStart(void)
{
  GtkWidget *mainwin;
  GdkModifierType modmask;

  win_move = TRUE;
  mainwin = RRScreenWindow();
  gdk_window_get_pointer(NULL, &cur_x, &cur_y, &modmask);
  /* -- ߤΥɥ */
  gdk_window_get_origin((GdkWindow*)RRScreenWindow()->window, &owx, &owy);

}

/* -------------------------------------------------------------
  RRMainDragEnd       -- ɥΥ줿

   return : void
   void
-------------------------------------------------------------- */
void  RRMainDragEnd(void)
{
  GdkModifierType modmask;

  win_move = FALSE;
  gdk_window_get_pointer(NULL, &cur_x, &cur_y, &modmask);
  gdk_window_get_origin((GdkWindow*)RRScreenWindow()->window, &owx, &owy);
}

/* -------------------------------------------------------------
  RRMainDragMove      -- ɥư

   return : void
   void
-------------------------------------------------------------- */
void  RRMainDragMove(void)
{
  gint  dx, dy, wx, wy;
  GdkModifierType modmask;

  if (win_move == TRUE) {
    gdk_window_get_pointer(NULL, &dx, &dy, &modmask);
    dx -= cur_x;
    dy -= cur_y;
    wx = owx + dx;
    wy = owy + dy;
    gdk_window_move((GdkWindow*)RRScreenWindow()->window, wx, wy);
  }
}



