/* =====================================================================

   LiMo - Theme clock
      Clock Theme Manage.  - ơޤδ

                                  Programed by Rero2 (K.Kunikane)

====================================================================== */

/* -------------------------------------------------------------
 --- History

  Mar.25.2001  

-------------------------------------------------------------- */

/* -------------------------------------------------------------
 --- Preface

  TMConfigRead     -- եեɤ߹
  TMConfigGet      -- ơ޹¤Υݥ󥿤ɤߤ
  TMConfigSet      -- ơ޹¤Υݥ󥿤δ
  TMConfigFree     -- եǡ,˴
  TMConfigBase     -- ١κؤ

-------------------------------------------------------------- */

/* -------------------------------------------------------------
 --- Include
-------------------------------------------------------------- */

#include <stdio.h>
#include <gtk/gtk.h>
#include <gdk-pixbuf/gdk-pixbuf.h>
#include <gdk-pixbuf/gdk-pixbuf-loader.h>
#include <gnome-xml/tree.h>
#include <gnome-xml/parser.h>
#include "tm_config.h"
#include "lm_rrda.h"

                

/* -------------------------------------------------------------
 --- Ƽ
-------------------------------------------------------------- */


/* -------------------------------------------------------------
 --- Structure
-------------------------------------------------------------- */


/* -------------------------------------------------------------
 --- ؿ
-------------------------------------------------------------- */

void  lmtc_init(LMTC *);
void  hari_init(CHAND *);
gchar *clean_content(gchar *);
gint  content_to_num(gchar *);
GdkPixbuf  *rrda_to_pixbuf(gchar *);
gboolean  set_config_xml(LMTC *);
gboolean  set_config_base(LMTC *, xmlNodePtr);
gboolean  set_config_analog(LMTC *, xmlNodePtr);
gboolean  set_config_digital(LMTC *, xmlNodePtr);
void  set_time_base(LMTC *, gint);

/* -------------------------------------------------------------
 --- ѿ
-------------------------------------------------------------- */

/* --- ߤΥեǡݻ  */
static LMTC  *now_conf;



/* -----------------------------------------------------------------------
 --- ץ
------------------------------------------------------------------------ */

/* -------------------------------------------------------------
  TMConfigRead     -- եեɤ߹

   return : LMTC *     - եݥ (NULL=Error)
   GString  *config    - եǡ̾

-------------------------------------------------------------- */
LMTC *TMConfigRead(gchar *config)
{
  LMTC *newconf = NULL;

  /* --- եեɤ߹ */
  lm_rrda_close();
  if (lm_rrda_open(config, "LMTC") == FALSE) {
    fprintf(stderr, "tm_config: rrda not open.\n");
    return(NULL);
  }

  /* ----- XML եǧ */
  /* --- ե¤Υꥢγ */
  newconf = g_new0(LMTC, 1);
  if (newconf == NULL) {
    fprintf(stderr, "tm_config: Memory allocate error \n");
    exit(-1);
  }
  /* ---  */
  lmtc_init(newconf);
  /* --- եե̾εϿ */
  newconf->configfile = g_new0(gchar, strlen(config)+1);
  strcpy(newconf->configfile, config);
  /* --- եեΥǡȿ */
  if (set_config_xml(newconf) == FALSE) {
    /* -- ʤˤ顼ä餷 */
    TMConfigFree(newconf);
    return(NULL);
  }

  /* --- ¥١̵ä饨顼 */
  if (newconf->base_pix == NULL) {
    fprintf(stderr, "tm_config: Base picture is not found.\n");
    exit(-1);
  }

  return(newconf);
}


/* -------------------------------------------------------------
  TMConfigGet      -- եǡ

   return : LMTC *     - ե¤Υݥ

-------------------------------------------------------------- */
LMTC *TMConfigGet(void)
{
  return(now_conf);
}


/* -------------------------------------------------------------
  TMConfigSet      -- եǡݻ

   return : LMTC *     - 쥳ե¤Υݥ
   LMTC  *theme        - եǡ

-------------------------------------------------------------- */
LMTC *TMConfigSet(LMTC *theme)
{
  LMTC *olddat;

  olddat = now_conf;
  now_conf = theme;
  return(olddat);
}


/* -------------------------------------------------------------
  TMConfigFree      -- եǡ,˴

   LMTC  *theme        - եǡ

-------------------------------------------------------------- */
void  TMConfigFree(LMTC *theme)
{
  lmtc_init(theme);
  g_free(theme);
}


/* -------------------------------------------------------------
  TMConfigBase      -- ١κؤ

   LMTC *theme  - եǡ
   gint num     - ١ֹ

-------------------------------------------------------------- */
void  TMConfigBase(LMTC *theme, gint num)
{
  set_time_base(theme, num);
}


/* -----------------------------------------------------------------------
 --- ⥵֥롼
------------------------------------------------------------------------ */

/* -------------------------------------------------------------
  hari_init     -- ʥ˥ǡν
-------------------------------------------------------------- */
void  hari_init(CHAND *hari)
{
  hari->sw = FALSE;
  if (hari->hari_data != NULL) {
    gdk_pixbuf_unref(hari->hari_data);
    hari->hari_data = NULL;
  }
  if (hari->hari_rot != NULL) {
    gdk_pixbuf_unref(hari->hari_rot);
    hari->hari_rot = NULL;
  }
  if (hari->hari_pix != NULL) {
    gdk_pixmap_unref(hari->hari_pix);
    hari->hari_pix = NULL;
  }
  if (hari->hari_mask != NULL) {
    gdk_bitmap_unref(hari->hari_mask);
    hari->hari_mask = NULL;
  }
  if (hari->hari_obj != NULL) {
    RRSpritemanDestroy(hari->hari_obj);
    hari->hari_obj = NULL;
  }
  hari->rot = hari->x = hari->y = 0;
}

/* -------------------------------------------------------------
  lmtc_init     -- եǡ,
-------------------------------------------------------------- */
void  lmtc_init(LMTC *theme)
{
  gint  i;

  if (theme == NULL) return;

  /* -- եǡ */
  if (theme->configfile != NULL) {
    g_free(theme->configfile);
  }
  theme->menu_sec = FALSE;
  /* -- ١ǡ */
  theme->base_num = 0;
  if (theme->base_pix != NULL) {
    gdk_pixmap_unref(theme->base_pix);
    theme->base_pix = NULL;
  }
  if (theme->base_mask != NULL) {
    gdk_bitmap_unref(theme->base_mask);
    theme->base_mask = NULL;
  }
  /* -- ʥץǡ */
  theme->analog_sw = theme->analog_sw = FALSE;
  hari_init(&(theme->hari_h));
  hari_init(&(theme->hari_m));
  hari_init(&(theme->hari_s));
  /* -- ǥץǡ */
  theme->digital_sw = FALSE;
  theme->digital_sec_sw = FALSE;
  theme->digital_colon_sw = FALSE;
  if (theme->digital_pix != NULL) {
    gdk_pixmap_unref(theme->digital_pix);
    theme->digital_pix = NULL;
  }
  if (theme->digital_mask != NULL) {
    gdk_bitmap_unref(theme->digital_mask);
    theme->digital_mask = NULL;
  }
  for(i=0; i<8; i++) {
    if (theme->digital_obj[i] != NULL) {
      RRSpritemanDestroy(theme->digital_obj[i]);
      theme->digital_obj[i] = NULL;
    }
  }
}


/* -------------------------------------------------------------
  clean_content      -- XML content 
-------------------------------------------------------------- */
gchar  *clean_content(gchar *content)
{
  gchar *nm;
  gint p, i, size;

  size = strlen(content);
  nm = g_malloc0(size);
  p = 0;
  for(i=0; i<size; i++) {
    if ((content[i] != ' ') && (content[i] != '\t') && (content[i] != '\n')) {
      nm[p] = content[i];
      p++;
    }
  }
  return(nm);
}


/* -------------------------------------------------------------
  content_to_num      -- XML content Ѵ
-------------------------------------------------------------- */
gint content_to_num(gchar *content)
{
  gchar *cc;
  gint  val;

  cc = clean_content(content);
  sscanf(cc, "%d", &val);

  g_free(cc);

  return(val);
}


/* -------------------------------------------------------------
  rrda_to_pixbuf     -- RRDA⤫եФPIXBUFѴ
-------------------------------------------------------------- */
GdkPixbuf  *rrda_to_pixbuf(gchar *name)
{
  GdkPixbuf  *pb;
  GdkPixbufLoader *loader;
  gint  size;
  gpointer   *data;
  gchar  *nm;

  /* --- ʸΥå */
  size = strlen(name);
  if (size == 0) {
    fprintf(stderr, "RRDA: Data read error (%s)\n", (char*)name);
    exit(-1);
  }

  /* --- ;򤬤äڤȤ */
  nm = clean_content(name);

  /* --- ǡɤ߹ */
  size = lm_rrda_data_size(nm);
  data = lm_rrda_load_data(nm);
  if (size == 0) {
    fprintf(stderr, "RRDA: Data read error (%s)\n", (char*)nm);
    exit(-1);
  }
  loader = gdk_pixbuf_loader_new();
  if (gdk_pixbuf_loader_write(loader, (guchar*)data, size) == FALSE) {
    fprintf(stderr, "RRDA: Data read error (%s)\n", (char*)nm);
    exit(-1);
  }
  pb = gdk_pixbuf_loader_get_pixbuf(loader);
  gdk_pixbuf_loader_close(loader);
  g_free(data);
  g_free(nm);

  return(pb);
}


/* -------------------------------------------------------------
  set_config_xml   --եե뤫ǡФ
-------------------------------------------------------------- */
gboolean  set_config_xml(LMTC *theme)
{
  xmlDocPtr  doc;
  xmlNodePtr node;
  gpointer   *data;
  gint       size;
  gboolean   base_flag = FALSE;

  /* --- XML config եɤ߹ */
  size = lm_rrda_data_size("config");
  if (size == 0) {
    fprintf(stderr, "tm_config: XML config file not found.\n");
    return(FALSE);
  }
  data = lm_rrda_load_data("config");
  if (data == 0) {
    fprintf(stderr, "tm_config: XML config file not found.\n");
    return(FALSE);
  }
  doc = xmlParseMemory((char*)data, size);
  if (doc == 0) {
    fprintf(stderr, "tm_config: XML parse error.\n");
    return(FALSE);
  }

  /* --- XML ǡ¤¸߳ǧ */
  if ((doc->root == NULL) || (doc->root->name == NULL) ||
      (g_strcasecmp(doc->root->name, "lm_tmclock") != 0)) {
    xmlFreeDoc(doc);
    fprintf(stderr, "tm_config: Data don't have XML structure.\n");
    return(FALSE);
  }

  /* --- tm_config Υǡǧ */
  theme->analog_sw = FALSE;
  theme->digital_sw = FALSE;
  for(node = doc->root->childs; node != NULL; node = node->next) {
    if (g_strcasecmp(node->name, "base") == 0) {
      base_flag = set_config_base(theme, node);
    }
    if (g_strcasecmp(node->name, "analog") == 0) {
      set_config_analog(theme, node);
    }
    if (g_strcasecmp(node->name, "digital") == 0) {
      set_config_digital(theme, node);
    }
  }
  if (base_flag == FALSE) {
    fprintf(stderr, "tm_config: XML don't have base node.\n");
    xmlFreeDoc(doc);
    return(FALSE);
  }

  /* --- XML */
  xmlFreeDoc(doc);

  return(TRUE);
}

/* ----- ١ܤɤ߹ */
gboolean set_config_base(LMTC *theme, xmlNodePtr node)
{
  GdkPixbuf  *loadpix;
  xmlNodePtr child;
  gboolean  ret = FALSE;

  for(child = node->childs; child != NULL; child = child->next) {
    if (g_strcasecmp(child->name, "base_org") == 0) {
      /* --- ١ */
      loadpix = rrda_to_pixbuf(child->childs->content);
      if (loadpix != NULL) {
	gdk_pixbuf_render_pixmap_and_mask(loadpix, &theme->base_pix,
					  &theme->base_mask, 128);
	theme->base_w = gdk_pixbuf_get_width(loadpix);
	theme->base_h = gdk_pixbuf_get_height(loadpix);
	gdk_pixbuf_unref(loadpix);
	ret = TRUE;
      }
    }
  }
  return(ret);
}

/* ----- ʥɤ߹ */
gboolean set_config_analog(LMTC *theme, xmlNodePtr node)
{
  xmlNodePtr child;
  gboolean  ret = FALSE;
  gchar  *content;

  for(child = node->childs; child != NULL; child = child->next) {
    /* -- û */
    if (g_strcasecmp(child->name, "hari_h") == 0) {
      theme->hari_h.hari_data = rrda_to_pixbuf(child->childs->content);
      theme->hari_h.sw = TRUE;
      theme->hari_h.hari_obj = RRSpritemanNew();
    }
    /* -- Ĺ */
    if (g_strcasecmp(child->name, "hari_m") == 0) {
      theme->hari_m.hari_data = rrda_to_pixbuf(child->childs->content);
      theme->hari_m.sw = TRUE;
      theme->hari_m.hari_obj = RRSpritemanNew();
    } 
    /* -- ÿ */
    if (g_strcasecmp(child->name, "hari_s") == 0) {
      theme->hari_s.hari_data = rrda_to_pixbuf(child->childs->content);
      theme->hari_s.sw = TRUE;
      theme->hari_s.hari_obj = RRSpritemanNew();
    } 
    /* -- ÿˤΤʤ */
    if (g_strcasecmp(child->name, "sec") == 0) {
      content = clean_content(child->childs->content);
      if (g_strcasecmp(content, "on") == 0) {
	theme->menu_sec = TRUE;
	theme->hari_sec_sw = TRUE;
      }
      else {
	theme->menu_sec = FALSE;
	theme->hari_sec_sw = FALSE;
      }
      if (g_strcasecmp(content, "off") == 0) {
	theme->menu_sec = FALSE;
	theme->hari_sec_sw = FALSE;
      }
      g_free(content);
    }
    /* -- ûˤΰ */
    if (g_strcasecmp(child->name, "h_xpos") == 0) {
      theme->hari_h.x = content_to_num(child->childs->content);
    }
    if (g_strcasecmp(child->name, "h_ypos") == 0) {
      theme->hari_h.y = content_to_num(child->childs->content);
    }
    /* -- Ĺˤΰ */
    if (g_strcasecmp(child->name, "m_xpos") == 0) {
      theme->hari_m.x = content_to_num(child->childs->content);
    }
    if (g_strcasecmp(child->name, "m_ypos") == 0) {
      theme->hari_m.y = content_to_num(child->childs->content);
    }
    /* -- ÿˤΰ */
    if (g_strcasecmp(child->name, "s_xpos") == 0) {
      theme->hari_s.x = content_to_num(child->childs->content);
    }
    if (g_strcasecmp(child->name, "s_ypos") == 0) {
      theme->hari_s.y = content_to_num(child->childs->content);
    }
  }

  /* --- ǡå */
  if ((theme->hari_h.hari_data != 0) && (theme->hari_m.hari_data != 0)) {
    theme->analog_sw = TRUE;
    ret = TRUE;
  }

  return(ret);
}

/* ----- ǥɤ߹ */
gboolean set_config_digital(LMTC *theme, xmlNodePtr node)
{
  GdkPixbuf  *loadpix;
  gint  i;
  xmlNodePtr child;
  gboolean  ret = FALSE;
  gchar  *content;

  for(child = node->childs; child != NULL; child = child->next) {
    /* --- ǥ */
    if (g_strcasecmp(child->name, "parts") == 0) {
      loadpix = rrda_to_pixbuf(child->childs->content);
      if (loadpix != NULL) {
	gdk_pixbuf_render_pixmap_and_mask(loadpix, &theme->digital_pix,
					  &theme->digital_mask, 128);
	theme->digital_w = gdk_pixbuf_get_width(loadpix) / 14;
	theme->digital_h = gdk_pixbuf_get_height(loadpix);
	gdk_pixbuf_unref(loadpix);
	/* --- ץ饤ȤƤ */
	for(i=0; i<8; i++) {
	  theme->digital_obj[i] = RRSpritemanNew();
	  theme->digital_obj[i]->sw = FALSE;
	  theme->digital_obj[i]->z = 100;
	  theme->digital_obj[i]->obj.mask_offset = TRUE;
	  theme->digital_obj[i]->obj.objmap = theme->digital_pix;
	  theme->digital_obj[i]->obj.objmask = theme->digital_mask;
	  theme->digital_obj[i]->obj.x = 0;
	  theme->digital_obj[i]->obj.y = 0;
	  theme->digital_obj[i]->obj.w = theme->digital_w;
	  theme->digital_obj[i]->obj.h = theme->digital_h;
	  theme->digital_obj[i]->obj.ox = 0;
	  theme->digital_obj[i]->obj.oy = 0;
	  theme->digital_obj[i]->obj.offset_x = 0;
	  theme->digital_obj[i]->obj.offset_y = 0;
	}
      }
    }
    /* --- ɽå */
    if (g_strcasecmp(child->name, "colon") == 0) {
      content = clean_content(child->childs->content);
      if (g_strcasecmp(content, "on") == 0) {
	theme->digital_colon_sw = TRUE;
      }
      else {
	theme->digital_colon_sw = FALSE;
      }
      if (g_strcasecmp(content, "off") == 0) {
	theme->digital_colon_sw = FALSE;
      }
      g_free(content);
    }
    /* --- ɽå */
    if (g_strcasecmp(child->name, "sec") == 0) {
      content = clean_content(child->childs->content);
      if (g_strcasecmp(content, "on") == 0) {
	theme->digital_sec_sw = TRUE;
      }
      else {
	theme->digital_sec_sw = FALSE;
      }
      if (g_strcasecmp(content, "off") == 0) {
	theme->digital_sec_sw = FALSE;
      }
      g_free(content);
    }
    /* --- ɽ 1 */
    if (g_strcasecmp(child->name, "ap_xpos") == 0) {
      theme->digital_obj[0]->obj.x = content_to_num(child->childs->content);
      theme->digital_obj[0]->sw = TRUE;
    }
    if (g_strcasecmp(child->name, "ap_ypos") == 0) {
      theme->digital_obj[0]->obj.y = content_to_num(child->childs->content);
      theme->digital_obj[0]->sw = TRUE;
    }
    /* --- ɽ 2 */
    if (g_strcasecmp(child->name, "h1_xpos") == 0) {
      theme->digital_obj[1]->obj.x = content_to_num(child->childs->content);
      theme->digital_obj[1]->sw = TRUE;
    }
    if (g_strcasecmp(child->name, "h1_ypos") == 0) {
      theme->digital_obj[1]->obj.y = content_to_num(child->childs->content);
      theme->digital_obj[1]->sw = TRUE;
    }
    /* --- ɽ 3 */
    if (g_strcasecmp(child->name, "h2_xpos") == 0) {
      theme->digital_obj[2]->obj.x = content_to_num(child->childs->content);
      theme->digital_obj[2]->sw = TRUE;
    }
    if (g_strcasecmp(child->name, "h2_ypos") == 0) {
      theme->digital_obj[2]->obj.y = content_to_num(child->childs->content);
      theme->digital_obj[2]->sw = TRUE;
    }
    /* --- ɽ 4 */
    if (g_strcasecmp(child->name, "cl_xpos") == 0) {
      theme->digital_obj[3]->obj.x = content_to_num(child->childs->content);
      theme->digital_obj[3]->sw = TRUE;
    }
    if (g_strcasecmp(child->name, "cl_ypos") == 0) {
      theme->digital_obj[3]->obj.y = content_to_num(child->childs->content);
      theme->digital_obj[3]->sw = TRUE;
    }
    /* --- ɽ 5 */
    if (g_strcasecmp(child->name, "m1_xpos") == 0) {
      theme->digital_obj[4]->obj.x = content_to_num(child->childs->content);
      theme->digital_obj[4]->sw = TRUE;
    }
    if (g_strcasecmp(child->name, "m1_ypos") == 0) {
      theme->digital_obj[4]->obj.y = content_to_num(child->childs->content);
      theme->digital_obj[4]->sw = TRUE;
    }
    /* --- ɽ 6 */
    if (g_strcasecmp(child->name, "m2_xpos") == 0) {
      theme->digital_obj[5]->obj.x = content_to_num(child->childs->content);
      theme->digital_obj[5]->sw = TRUE;
    }
    if (g_strcasecmp(child->name, "m2_ypos") == 0) {
      theme->digital_obj[5]->obj.y = content_to_num(child->childs->content);
      theme->digital_obj[5]->sw = TRUE;
    }
    /* --- ɽ 7 */
    if (g_strcasecmp(child->name, "s1_xpos") == 0) {
      theme->digital_obj[6]->obj.x = content_to_num(child->childs->content);
      theme->digital_obj[6]->sw = TRUE;
    }
    if (g_strcasecmp(child->name, "s1_ypos") == 0) {
      theme->digital_obj[6]->obj.y = content_to_num(child->childs->content);
      theme->digital_obj[6]->sw = TRUE;
    }
    /* --- ɽ 8 */
    if (g_strcasecmp(child->name, "s2_xpos") == 0) {
      theme->digital_obj[7]->obj.x = content_to_num(child->childs->content);
      theme->digital_obj[7]->sw = TRUE;
    }
    if (g_strcasecmp(child->name, "s2_ypos") == 0) {
      theme->digital_obj[7]->obj.y = content_to_num(child->childs->content);
      theme->digital_obj[7]->sw = TRUE;
    }
  }

  /* --- ǡå */
  if (theme->digital_pix != 0) {
    theme->digital_sw = TRUE;
    ret = TRUE;
  }

  return(ret);
}


/* -------------------------------------------------------------
  set_time_base   --֤˱١
-------------------------------------------------------------- */
void  set_time_base(LMTC *theme, gint t)
{
  xmlDocPtr  doc;
  xmlNodePtr node, child;
  GdkPixbuf  *loadpix;
  gpointer   *data;
  gint       size;
  gchar      timebase[10];

  /* --- XML config եɤ߹ */
  size = lm_rrda_data_size("config");
  if (size == 0) {
    fprintf(stderr, "tm_config: XML config file not found.\n");
    return;
  }
  data = lm_rrda_load_data("config");
  if (data == 0) {
    fprintf(stderr, "tm_config: XML config file not found.\n");
    return;
  }
  doc = xmlParseMemory((char*)data, size);
  if (doc == 0) {
    fprintf(stderr, "tm_config: XML parse error.\n");
    return;
  }

  /* --- XML ǡ¤¸߳ǧ */
  if ((doc->root == NULL) || (doc->root->name == NULL) ||
      (g_strcasecmp(doc->root->name, "lm_tmclock") != 0)) {
    xmlFreeDoc(doc);
    fprintf(stderr, "tm_config: Data don't have XML structure.\n");
    return;
  }

  /* --- tm_config Υǡǧ */
  sprintf(timebase, "base_%02d", t);
  for(node = doc->root->childs; node != NULL; node = node->next) {
    if (g_strcasecmp(node->name, "base") == 0) {
      set_config_base(theme, node);
      /* --- ١õ */
      for(child = node->childs; child != NULL; child = child->next) {
	if (g_strcasecmp(child->name, timebase) == 0) {
	  /* -- ȯ */
	  loadpix = rrda_to_pixbuf(child->childs->content);
	  if (loadpix != NULL) {
	    gdk_pixbuf_render_pixmap_and_mask(loadpix, &theme->base_pix,
					      &theme->base_mask, 128);
	    theme->base_w = gdk_pixbuf_get_width(loadpix);
	    theme->base_h = gdk_pixbuf_get_height(loadpix);
	    gdk_pixbuf_unref(loadpix);
	  }
	}
      }
    }
  }

  /* --- XML */
  xmlFreeDoc(doc);
}



