/* =====================================================================

   LiMo - THeme clock
      Clock Display Manage.  - ơޥå̴

                                  Programed by Rero2 (K.Kunikane)

====================================================================== */

/* -------------------------------------------------------------
 --- History

  Mar.25.2001  

-------------------------------------------------------------- */

/* -------------------------------------------------------------
 --- Preface

  TMDispInit       -- (=ɽ)

-------------------------------------------------------------- */

/* -------------------------------------------------------------
 --- Include
-------------------------------------------------------------- */

#include  <time.h>
#include  <math.h>
#include  "tm_config.h"
#include  "rr_screen.h"
#include  "rr_spriteman.h"
#include  "lm_pix_rot.h"

/* -------------------------------------------------------------
 --- Ƽ
-------------------------------------------------------------- */

#define  SMOOTH_MODE   LM_PIXROT_NORMAL


/* -------------------------------------------------------------
 --- Structure
-------------------------------------------------------------- */


/* -------------------------------------------------------------
 --- ؿ
-------------------------------------------------------------- */

void  theme_base(LMTC *, time_t);
void  theme_digital(LMTC *, time_t);
void  theme_analog(LMTC *, time_t);
void  analog_hari(CHAND *, gint);


/* -------------------------------------------------------------
 --- ѿ
-------------------------------------------------------------- */

/* --- ١Υץ饤ȴ */
static RRSObj  *base_spr = NULL;

/* -----------------------------------------------------------------------
 --- ץ
------------------------------------------------------------------------ */

/* -------------------------------------------------------------
  TMDispInit       -- (=ɽ)

   return : void
   struct LMTC *theme  - ɽơ
   time_t now          - ɽ

-------------------------------------------------------------- */
void  TMDispInit(LMTC *theme, time_t now)
{
  gint  i;

  /* --- طʥץ饤 */
  RRSpritemanBGDestroy(base_spr);
  base_spr = RRSpritemanBGNew();
  theme->base_num = -1;
  theme_base(theme, now);

  /* --- ʥʬ */
  theme->hari_h.rot = -1;
  theme->hari_m.rot = -1;
  theme->hari_s.rot = -1;
  theme_analog(theme, now);

  /* --- ǥʬ */
  if (theme->digital_sw == TRUE) {
    for(i=0; i<6; i++) {
      theme->digital_obj[i]->sw = TRUE;
      theme->digital_obj[i]->obj.sw = TRUE;
    }
    if (theme->digital_sec_sw == TRUE) {
      theme->digital_obj[6]->sw = TRUE;
      theme->digital_obj[7]->sw = TRUE;
      theme->digital_obj[6]->obj.sw = TRUE;
      theme->digital_obj[7]->obj.sw = TRUE;
    }
    else {
      theme->digital_obj[6]->sw = FALSE;
      theme->digital_obj[7]->sw = FALSE;
    }
    theme->digital_obj[3]->obj.ox = 11 * theme->digital_w;
  }
  theme_digital(theme, now);

}


/* -------------------------------------------------------------
  TMDispSet        -- ̾ɽ(=ʬɽ)

   return : void
   struct LMTC *theme  - ɽơ
   time_t now          - ɽ

-------------------------------------------------------------- */
void  TMDispSet(LMTC *theme, time_t now)
{
  theme_analog(theme, now);
  theme_digital(theme, now);
}


/* -----------------------------------------------------------------------
 --- ⥵֥롼
------------------------------------------------------------------------ */

/* -------------------------------------------------------------
  theme_base    -- ١ǥץ쥤,ѹ 
-------------------------------------------------------------- */
void  theme_base(LMTC *theme, time_t time)
{
  struct tm  *timedata;

  /* --- ˱pixmapѰ */
  timedata = localtime(&time);
  if (timedata->tm_hour != theme->base_num) {
    TMConfigBase(theme, timedata->tm_hour);
    theme->base_num = timedata->tm_hour;
  }

  /* --- ١򥦥ɥ */
  RRScreenFree();
  gtk_widget_set_usize(RRScreenWindow(), theme->base_w, theme->base_h);
  RRScreenInit(RRScreenWindow(), RRScreenCanvas(),
	       theme->base_w, theme->base_h, TRUE);
  RRScreenWinShape(theme->base_mask);
  base_spr->sw = TRUE;
  base_spr->update = TRUE;
  base_spr->z = 0;
  base_spr->obj.sw = TRUE;
  base_spr->obj.mask_offset = TRUE;
  base_spr->obj.objmap = theme->base_pix;
  base_spr->obj.objmask = theme->base_mask;
  base_spr->obj.x = 0;
  base_spr->obj.y = 0;
  base_spr->obj.w = theme->base_w;
  base_spr->obj.h = theme->base_h;
  base_spr->obj.ox = 0;
  base_spr->obj.oy = 0;
  base_spr->obj.offset_x = 0;
  base_spr->obj.offset_y = 0;
}


/* -------------------------------------------------------------
  theme_digital   -- ǥǥץ쥤
-------------------------------------------------------------- */
void  theme_digital(LMTC *theme, time_t time)
{
  struct tm  *timedata;
  gint  tmp, n;

  /* --- ǥ̵ʤ齪λ */
  if (theme->digital_sw == FALSE) return;

  timedata = localtime(&time);
  /* -- AM/PM */
  tmp = timedata->tm_hour / 12;
  theme->digital_obj[0]->obj.ox = (12 + tmp) * theme->digital_w;
  /* -- hour */
  tmp = timedata->tm_hour % 12;
  n = tmp / 10;
  theme->digital_obj[1]->obj.ox = n * theme->digital_w;
  n = tmp % 10;
  theme->digital_obj[2]->obj.ox = n * theme->digital_w;
  /* -- min */
  tmp = timedata->tm_min;
  n = tmp / 10;
  theme->digital_obj[4]->obj.ox = n * theme->digital_w;
  n = tmp % 10;
  theme->digital_obj[5]->obj.ox = n * theme->digital_w;
  /* -- sec */
  if (theme->digital_sec_sw == TRUE) {
    tmp = timedata->tm_sec;
    n = tmp / 10;
    theme->digital_obj[6]->obj.ox = n * theme->digital_w;
    n = tmp % 10;
    theme->digital_obj[7]->obj.ox = n * theme->digital_w;
  }
  /* -- colon */
  if (theme->digital_colon_sw == TRUE) {
    tmp = timedata->tm_sec % 2;
    theme->digital_obj[3]->obj.ox = (tmp + 10) * theme->digital_w;
  }
}


/* -------------------------------------------------------------
  theme_analog   -- ʥǥץ쥤
-------------------------------------------------------------- */
void  theme_analog(LMTC *theme, time_t time)
{
  struct tm  *timedata;
  gint  now[3];

  /* --- ʥ̵ʤ齪λ */
  if (theme->analog_sw == FALSE) return;

  /* --- ʥˤγٻ */
  timedata = localtime(&time);
  now[0] = (360 * (timedata->tm_hour % 12) / 12) +
    (30 * timedata->tm_min / 60);
  now[1] = 360 * timedata->tm_min / 60;
  now[2] = 360 * timedata->tm_sec / 60;

  /* ---  */
  if (now[0] != theme->hari_h.rot) {
    theme->hari_h.rot = now[0];
    analog_hari(&theme->hari_h, 300);
  }
  /* --- ʬ */
  if (now[1] != theme->hari_m.rot) {
    theme->hari_m.rot = now[1];
    analog_hari(&theme->hari_m, 200);
  }
  /* --- ÿ */
  if ((theme->hari_sec_sw == TRUE) && (now[2] != theme->hari_s.rot)) {
    theme->hari_s.rot = now[2];
    analog_hari(&theme->hari_s, 100);
  }
}


/* -------------------------------------------------------------
  analog_hari   -- ʥˤɽ
-------------------------------------------------------------- */
void  analog_hari(CHAND *h, gint depth)
{
  gfloat  r;

  if (h->hari_data != NULL) {
    if (h->hari_rot != NULL) {
      gdk_pixbuf_unref(h->hari_rot);
      h->hari_rot = NULL;
    }
    if (h->hari_pix != NULL) {
      gdk_pixmap_unref(h->hari_pix);
      h->hari_pix = NULL;
    }
    if (h->hari_mask != NULL) {
      gdk_bitmap_unref(h->hari_mask);
      h->hari_mask = NULL;
    }
    r = ((M_PI * 2.0) * (gfloat)h->rot) / 360.0;
    h->hari_rot = lm_pix_rot_new(h->hari_data,
				 r, 1.0, SMOOTH_MODE);
    gdk_pixbuf_render_pixmap_and_mask(h->hari_rot,
				      &h->hari_pix,
				      &h->hari_mask,
				      128);
    h->hari_obj->sw = TRUE;
    h->hari_obj->z = depth;
    h->hari_obj->obj.sw = TRUE;
    h->hari_obj->obj.mask_offset = TRUE;
    h->hari_obj->obj.objmap = h->hari_pix;
    h->hari_obj->obj.objmask = h->hari_mask;
    h->hari_obj->obj.x = h->x;
    h->hari_obj->obj.y = h->y;
    h->hari_obj->obj.w = gdk_pixbuf_get_width(h->hari_rot);
    h->hari_obj->obj.h = gdk_pixbuf_get_height(h->hari_rot);
    h->hari_obj->obj.offset_x = h->hari_obj->obj.w / 2;
    h->hari_obj->obj.offset_y = h->hari_obj->obj.h / 2;
  }
}
